Pivot Table Serialize/Deserialize

You can serialize the current state of the pivot table data and restore or deserialize the saved state later as needed. Serialization supports the following pivot table data: Fields, Options, Filter, Sort, Layout, PivotTable Position, and Theme.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

PivotTables support serialization/deserialization.

The SerializeInfo returned by the serialize() API can only be used in pivot tables under the same data source.

Serialize & Deserialize

Serialization supports the following data:

Fields, Options, Filter, Sort, Layout, PivotTable Position, Theme

ISerializeInfo Interface

interface GC.Spread.Pivot.ISerializeInfo
{
    layoutType?:  GC.Spread.Pivot.PivotTableLayoutType;
    options?: object;
    theme?: string;
    valuePosition?: GC.Pivot.IDataPosition;
    pivotTablePosition?: number[];
    fieldsInfo?: GC.Spread.Pivot.ISerializeFieldInfo[][];
    styles?: GC.Spread.Pivot.IPivotStyle[];
    collapseItems?: object;
    showDataAsList?: GC.Spread.Pivot.ISerializeShowDataAsInfo[];
}

interface GC.Spread.Pivot.ISerializeFieldInfo {
    sourceName: string;
    displayName: string; 
    subtotal?:  GC.Pivot.SubtotalType;
    labelFilter?:  GC.Spread.Pivot.IPivotTextFilterInfo | GC.Spread.Pivot.IPivotConditionFilterInfo;
    valueFilter?:  GC.Spread.Pivot.IPivotConditionFilterInfo;
    sortInfo?:  GC.Spread.Pivot.IPivotTableSortInfo;
}

API

///* function serialize (): GC.Spread.Pivot.ISerializeInfo
/**
* @description get serialized pivot table data
* @returns {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
serialize (): GC.Spread.Pivot.ISerializeInfo

///* function deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)
/**
* @description restore serialized pivot table data to a existed pivot table
* @param {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)

Sample Code

    var spread = new GC.Spread.Sheets.workbook(document.getElementById("ss"),{sheetCount:3});
    var sourceSheet = spread.getSheet(0);
    var sheet = spread.getSheet(1);
    var sourceData = [["Date","Buyer","Type","Amount"],
                      ["01-Jan","Mom","Fuel",74],
                      ["15-Jan","Mom","Food",235],
                      ["17-Jan","Dad","Sports",20],
                      ["21-Jan","Kelly","Books",125]];
    sourceSheet.setArray(0, 0, sourceData );
    sourceSheet.tables.add('sourceData', 0, 0, 5, 4);
    var layout = GC.Spread.Pivot.PivotTableLayoutType.compact;
    var theme = GC.Spread.Pivot.PivotTableThemes.medium2;
    var options = {showRowHeader: true, showColumnHeader: true};
    var pivotTable = sheet.pivotTables.add("pivotTable_1", 'sourceData', 1, 1, layout, theme, options);
    pivotTable.add("Buyer","Buyer",GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("Type","Type",GC.Spread.Pivot.PivotTableFieldType.columnField);
    pivotTable.add("Amount","Sum of Amount",GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    var serialization = pivotTable.serialize();
    pivotTable.remove('Type');
    pivotTable.deserialize(serialization);
PivotTables support serialization/deserialization. The SerializeInfo returned by the serialize() API can only be used in pivot tables under the same data source. Serialize & Deserialize Serialization supports the following data: Fields, Options, Filter, Sort, Layout, PivotTable Position, Theme ISerializeInfo Interface API Sample Code
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 }); initSpread(spread); var pivotLayoutSheet = spread.getSheet(0); var pt = initPivotTable(pivotLayoutSheet); bindEvent(pt); }; function initSpread(spread) { spread.suspendPaint(); let sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, pivotSales); let sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); spread.resumePaint(); } function initPivotTable(sheet) { let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light1); myPivotTable.suspendLayout(); myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField); let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); myPivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let itemList = ["Alan","John", "Tess"]; myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } }); let carList = ["Audi","BMW","Mercedes"]; myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } }); let panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel")); panel.sectionVisibility(GC.Spread.Pivot.PivotPanelSection.fields + GC.Spread.Pivot.PivotPanelSection.area); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); return myPivotTable; } function _getElementById(id) { return document.getElementById(id); } function bindEvent(pt){ _getElementById("Serialize").addEventListener("click", function(event){ let info = JSON.stringify(pt.serialize(), null, 2); _getElementById("serializeInfo").value = info; }); _getElementById("Deserialize").addEventListener("click", function(event){ try { let info = JSON.parse(_getElementById("serializeInfo").value); pt.deserialize(info); } catch (e) { alert("invalid serialize info!"); } }); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="sample-panel"> <div id="panel"></div> </div> <div id="container" class="options-container"> <span><u>Serialize Info:</u></span> <br /> <div class="option-row">Click the <b>Serialize</b> button to save the current state/view of the pivot table data.</div> <div class="option-row">You can make further changes to the pivot table fields, and click <b>Deserialize</b> to restore the original data view.</div> <br /> <input type="button" value="Serialize" class="set-option" id="Serialize"> <input type="button" value="Deserialize" class="set-option" id="Deserialize"> <br><br> <textarea name="serializeInfo" id="serializeInfo" cols="30" rows="50"></textarea> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 600px); height: 100%; overflow: hidden; display: inline-block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; overflow: hidden; } .sample-panel { width: 292px; padding: 1px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; display: inline-block; } .gc-panel { padding: 10px; background-color: rgb(230, 230, 230); } #panel { right: 0; width: 292px; height: 100%; top: 0; } #app { height: 100%; } .options-container { width: 292px; padding: 1px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; display: inline-block; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } div > textarea { overflow: scroll; width: 100%; height: calc(100% - 100px); outline: none; box-sizing: border-box; } div > span { display: inline-block; margin: 5px; white-space: pre; }

PivotTables support serialization/deserialization.
The SerializeInfo returned by the serialize() API can only be used in pivot tables under the same data source.
Serialize & Deserialize
Serialization supports the following data:
Fields, Options, Filter, Sort, Layout, PivotTable Position, Theme
ISerializeInfo Interface
API
Sample Code
<template>
<div class="sample-tutorial">
<gc-spread-sheets
class="sample-spreadsheets"
@workbookInitialized="initSpread"
>
<gc-worksheet> </gc-worksheet>
<gc-worksheet> </gc-worksheet>
</gc-spread-sheets>
<div class="sample-panel">
<div id="panel"></div>
</div>
<div id="container" class="options-container">
<span><u>Serialize Info:</u></span>
<br />
<div class="option-row">Click the <b>Serialize</b> button to save the current state/view of the pivot table data.</div>
<div class="option-row">You can make further changes to the pivot table fields, and click <b>Deserialize</b> to restore the original data view.</div>
<br />
<input type="button" value="Serialize" class="set-option" id="Serialize" v-on:click="serialize()">
<input type="button" value="Deserialize" class="set-option" id="Deserialize" v-on:click="deserialize()">
<br><br>
<textarea name="serializeInfo" id="serializeInfo" cols="30" rows="50" v-model="serializeInfoRef"></textarea>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
let serializeInfoRef = shallowRef(null);
let ptRef = shallowRef(null);
function initSpread (spread) {
initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
ptRef.value = initPivotTable(pivotLayoutSheet);
}
function initSheets (spread) {
spread.suspendPaint();
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, pivotSales);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
function initPivotTable (sheet) {
let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light1);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan","John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
let carList = ["Audi","BMW","Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
let panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel"));
panel.sectionVisibility(GC.Spread.Pivot.PivotPanelSection.fields + GC.Spread.Pivot.PivotPanelSection.area);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
function serialize () {
let info = ptRef.value.serialize();
serializeInfoRef.value = JSON.stringify(info, null, 2);
}
function deserialize () {
try {
let info = JSON.parse(serializeInfoRef.value);
ptRef.value.deserialize(info);
} catch (e) {
alert("invalid serialize info!");
}
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: calc(100% - 600px);
height: 100%;
overflow: hidden;
display: inline-block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
overflow: hidden;
}
.sample-panel {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
}
.gc-panel {
padding: 10px;
background-color: rgb(230, 230, 230);
}
#panel {
right: 0;
width: 292px;
height: 100%;
top: 0;
}
#app {
height: 100%;
}
.options-container {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
font-size: 14px;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
div > textarea {
overflow: scroll;
width: 100%;
height: calc(100% - 100px);
outline: none;
box-sizing: border-box;
}
div > span {
display: inline-block;
margin: 5px;
white-space: pre;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

PivotTables support serialization/deserialization.
The SerializeInfo returned by the serialize() API can only be used in pivot tables under the same data source.
Serialize & Deserialize
Serialization supports the following data:
Fields, Options, Filter, Sort, Layout, PivotTable Position, Theme
ISerializeInfo Interface
API
Sample Code
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
let pt;
export const AppFunc = () => {
const [serializeInfo, setSerializeInfo] = useState('');
return (
<div className="sample-tutorial">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="sample-panel">
<div id="panel"></div>
</div>
<div id="container" class="options-container">
<span><u>Serialize Info:</u></span>
<br />
<div class="option-row">Click the <b>Serialize</b> button to save the current state/view of the pivot table data.</div>
<div class="option-row">You can make further changes to the pivot table fields, and click <b>Deserialize</b> to restore the original data view.</div>
<br />
<input type="button" value="Serialize" class="set-option" id="Serialize" onClick={() => { serialize(setSerializeInfo) }} />
<input type="button" value="Deserialize" class="set-option" id="Deserialize" onClick={() => { deserialize(serializeInfo) }} />
<br /><br />
<textarea name="serializeInfo" id="serializeInfo" cols="30" rows="50" value={serializeInfo} onChange={(e) => { setTextareaValue(e, setSerializeInfo) }}></textarea>
</div>
</div>
);
}
function setTextareaValue(e, setSerializeInfo) {
setSerializeInfo(e.target.value);
}
function initSpread(spread) {
initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
pt = initPivotTable(pivotLayoutSheet);
}
function initSheets(spread) {
spread.suspendPaint();
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, pivotSales);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
function initPivotTable(sheet) {
let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light1);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan", "John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
let carList = ["Audi", "BMW", "Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
let panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel"));
panel.sectionVisibility(GC.Spread.Pivot.PivotPanelSection.fields + GC.Spread.Pivot.PivotPanelSection.area);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
function serialize(setSerializeInfo) {
let ptInfo = pt.serialize();
setSerializeInfo(JSON.stringify(ptInfo, null, 2));
}
function deserialize(serializeInfo) {
try {
let info = JSON.parse(serializeInfo);
pt.deserialize(info);
} catch (e) {
alert("invalid serialize info!");
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: calc(100% - 600px);
height: 100%;
overflow: hidden;
display: inline-block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
overflow: hidden;
}
.sample-panel {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
}
.gc-panel {
padding: 10px;
background-color: rgb(230, 230, 230);
}
#panel {
right: 0;
width: 292px;
height: 100%;
top: 0;
}
#app {
height: 100%;
}
.options-container {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
div > textarea {
overflow: scroll;
width: 100%;
height: calc(100% - 100px);
outline: none;
box-sizing: border-box;
}
div > span {
display: inline-block;
margin: 5px;
white-space: pre;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

PivotTables support serialization/deserialization.
The SerializeInfo returned by the serialize() API can only be used in pivot tables under the same data source.
Serialize & Deserialize
Serialization supports the following data:
Fields, Options, Filter, Sort, Layout, PivotTable Position, Theme
ISerializeInfo Interface
API
Sample Code
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { FormsModule } from '@angular/forms';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 600px)',
height: '100%',
overflow: 'hidden',
display: "inline-block"
};
pt: any;
showFields = true;
showArea = true;
showViewList = true;
displayStrategy = "0";
serializeInfo = "";
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
this.initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
this.pt = this.initPivotTable(pivotLayoutSheet);
}
initSheets (spread: GC.Spread.Sheets.Workbook) {
spread.suspendPaint();
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, pivotSales);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
spread.resumePaint();
}
initPivotTable(sheet: GC.Spread.Sheets.Worksheet) {
let myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light1);
myPivotTable.suspendLayout();
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
myPivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let itemList = ["Alan","John", "Tess"];
myPivotTable.labelFilter("Salesperson", { textItem: { list: itemList, isAll: false } });
let carList = ["Audi","BMW","Mercedes"];
myPivotTable.labelFilter("Cars", { textItem: { list: carList, isAll: false } });
let panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel"));
panel.sectionVisibility(GC.Spread.Pivot.PivotPanelSection.fields + GC.Spread.Pivot.PivotPanelSection.area);
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
return myPivotTable;
}
serialize () {
let info = this.pt.serialize();
this.serializeInfo = JSON.stringify(info, null, 2);
}
deserialize () {
try {
let info = JSON.parse(this.serializeInfo);
this.pt.deserialize(info);
} catch (e) {
alert("invalid serialize info!");
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet> </gc-worksheet>
<gc-worksheet> </gc-worksheet>
</gc-spread-sheets>
<div class="sample-panel">
<div id="panel"></div>
</div>
<div id="container" class="options-container">
<span><u>Serialize Info:</u></span>
<br />
<div class="option-row">Click the <b>Serialize</b> button to save the current state/view of the pivot table data.</div>
<div class="option-row">You can make further changes to the pivot table fields, and click <b>Deserialize</b> to restore the original data view.</div>
<br />
<input type="button" value="Serialize" class="set-option" id="Serialize" (click)="serialize()">
<input type="button" value="Deserialize" class="set-option" id="Deserialize" (click)="deserialize()">
<br><br>
<textarea name="serializeInfo" id="serializeInfo" cols="30" rows="50" [(ngModel)]="serializeInfo"></textarea>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: calc(100% - 600px);
height: 100%;
overflow: hidden;
display: inline-block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
overflow: hidden;
}
.sample-panel {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
}
.gc-panel {
padding: 10px;
background-color: rgb(230, 230, 230);
}
#panel {
right: 0;
width: 292px;
height: 100%;
top: 0;
}
#app {
height: 100%;
}
.options-container {
width: 292px;
padding: 1px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
display: inline-block;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
div > textarea {
overflow: scroll;
width: 100%;
height: calc(100% - 100px);
outline: none;
box-sizing: border-box;
}
div > span {
display: inline-block;
margin: 5px;
white-space: pre;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);